/*
* Copyright 2021 E.J.I.E., S.A.
*
* Licencia con arreglo a la EUPL, Versión 1.1 exclusivamente (la «Licencia»);
* Solo podrá usarse esta obra si se respeta la Licencia.
* Puede obtenerse una copia de la Licencia en
*
* http://ec.europa.eu/idabc/eupl.html
*
* Salvo cuando lo exija la legislación aplicable o se acuerde por escrito,
* el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
* SIN GARANT�?AS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
* Véase la Licencia en el idioma concreto que rige los permisos y limitaciones
* que establece la Licencia.
*/
package com.ejie.ad74a.service.ae01b;

import java.io.IOException;
import java.io.OutputStream;
import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.beanutils.BeanUtils;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.CellStyle;
import org.apache.poi.ss.usermodel.CreationHelper;
import org.apache.poi.ss.usermodel.Font;
import org.apache.poi.ss.usermodel.HorizontalAlignment;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.odftoolkit.odfdom.doc.OdfSpreadsheetDocument;
import org.odftoolkit.odfdom.doc.table.OdfTable;
import org.odftoolkit.odfdom.doc.table.OdfTableRow;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.support.ReloadableResourceBundleMessageSource;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ad74a.dao.MensualidadesAExonerarDao;
import com.ejie.ad74a.dao.MensualidadesDao;
import com.ejie.ad74a.dao.SolicitantesDao;
import com.ejie.ad74a.dao.ae01b.CopagosGestionImpagosDao;
import com.ejie.ad74a.exceptions.Ad74aException;
import com.ejie.ad74a.exceptions.ManagerErrors;
import com.ejie.ad74a.model.Avisos;
import com.ejie.ad74a.model.Mensualidades;
import com.ejie.ad74a.model.MensualidadesAExonerar;
import com.ejie.ad74a.model.Solicitantes;
import com.ejie.ad74a.model.ae01b.CopagosGestionImpagos;
import com.ejie.ad74a.service.MensualidadesService;
import com.ejie.ad74a.service.SolicitantesService;
import com.ejie.ad74a.util.comun.UtilLiterales;
import com.ejie.ad74a.util.comun.UtilidadesFecha;
import com.ejie.ad74a.util.constantes.Constantes;
import com.ejie.ad74a.ws.client.liquidaciones.CabeceraType;
import com.ejie.ad74a.ws.client.liquidaciones.ConceptoType;
import com.ejie.ad74a.ws.client.liquidaciones.DatosBancariosType;
import com.ejie.ad74a.ws.client.liquidaciones.DatosDireccionType;
import com.ejie.ad74a.ws.client.liquidaciones.DatosEmisionType;
import com.ejie.ad74a.ws.client.liquidaciones.DatosEmisionType.Conceptos;
import com.ejie.ad74a.ws.client.liquidaciones.DatosIdentificacionType;
import com.ejie.ad74a.ws.client.liquidaciones.Exception_Exception;
import com.ejie.ad74a.ws.client.liquidaciones.LiquidacionesService;
import com.ejie.ad74a.ws.client.liquidaciones.RespuestaType;
import com.ejie.ad74a.ws.client.liquidaciones.TipoOperacionEnum;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableResponseDto;
import com.ejie.x38.util.DateTimeManager;
import com.lowagie.text.Document;
import com.lowagie.text.Phrase;
import com.lowagie.text.pdf.PdfPCell;
import com.lowagie.text.pdf.PdfPTable;
import com.lowagie.text.pdf.PdfWriter;

/**
 * CopagosGestionImpagosServiceImpl generated by UDA, 28-jun-2023 10:59:26.
 * 
 * @author UDA
 */

@Service(value = "copagosGestionImpagosService")
public class CopagosGestionImpagosServiceImpl implements CopagosGestionImpagosService {

	private static final Logger logger = LoggerFactory.getLogger(CopagosGestionImpagosServiceImpl.class);

	@Autowired
	private CopagosGestionImpagosDao copagosGestionImpagosDao;

	@Autowired
	private SolicitantesService solicitantesService;

	@Autowired
	private MensualidadesService mensualidadesService;
	@Autowired
	private MensualidadesDao mensualidadesDao;

	@Autowired
	private MensualidadesAExonerarDao mensualidadesAExonerarDao;
	@Autowired
	private SolicitantesDao solicitantesDao;

	@Resource
	private ReloadableResourceBundleMessageSource appMessageSource;

	@Transactional(rollbackFor = Throwable.class)
	@Override
	public void exoneracionMensualidades(CopagosGestionImpagos copagosGestionImpagos) {

		CopagosGestionImpagosServiceImpl.logger
				.info("Inicio exoneracionMensualidades para solicitante:" + copagosGestionImpagos.getIdSolicitante());
		MensualidadesAExonerar mensualidadesAExonerar = new MensualidadesAExonerar();
		mensualidadesAExonerar.setIdSolicitante(Long.valueOf(copagosGestionImpagos.getIdSolicitante()));
		// actualizar mensualidades
		List<MensualidadesAExonerar> listMensualidadesAExonerar = mensualidadesAExonerarDao
				.findAll(mensualidadesAExonerar, null);
		for (MensualidadesAExonerar mensualidadesAExonerarElem : listMensualidadesAExonerar) {
			Mensualidades mensualidades = new Mensualidades(mensualidadesAExonerarElem.getIdMensualidad());
			mensualidades.setExoneracion89(Constantes.UNO);
			mensualidadesDao.updateExoneracion(mensualidades);
			// TODO con servicio web anular liquidaciones pendientes de pago
			// cuidado puede haber liquidaciones repetidas, controlar no llamar varias veces
			// al WS para anular la misma liquidacion
		}
		// actualizar solicitante
		Solicitantes solicitante = new Solicitantes(mensualidadesAExonerar.getIdSolicitante());
		solicitante.setExoneracion01(Constantes.UNO);
		solicitante.setMotivoExoneracion01(copagosGestionImpagos.getMotivoExoneracion());
		solicitantesDao.updateExoneracion(solicitante);

		CopagosGestionImpagosServiceImpl.logger
				.info("Fin exoneracionMensualidades para solicitante:" + copagosGestionImpagos.getIdSolicitante());
	}

	/**
	 * Finds a list of rows in the CopagosGestionImpagos table.
	 *
	 * @param copagosGestionImpagos CopagosGestionImpagos
	 * @param tableRequestDto       TableRequestDto
	 *
	 * @return List<CopagosGestionImpagos>
	 */
	public List<CopagosGestionImpagos> findAll(CopagosGestionImpagos copagosGestionImpagos,
			TableRequestDto tableRequestDto) {
		return (List<CopagosGestionImpagos>) this.copagosGestionImpagosDao.findAll(copagosGestionImpagos,
				tableRequestDto);
	}

	/**
	 * Finds rows in the CopagosGestionImpagos table using like.
	 *
	 * @param copagosGestionImpagos CopagosGestionImpagos
	 * @param tableRequestDto       TableRequestDto
	 * @param startsWith            Boolean
	 * 
	 * @return List<CopagosGestionImpagos>
	 */
	public List<CopagosGestionImpagos> findAllLike(CopagosGestionImpagos copagosGestionImpagos,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		return (List<CopagosGestionImpagos>) this.copagosGestionImpagosDao.findAllLike(copagosGestionImpagos,
				tableRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter method in the CopagosGestionImpagos table.
	 *
	 * @param filterCopagosGestionImpagos CopagosGestionImpagos
	 * @param tableRequestDto             TableRequestDto
	 * @param startsWith                  Boolean
	 *
	 * @return TableResponseDto<CopagosGestionImpagos>
	 */
	public TableResponseDto<CopagosGestionImpagos> filter(CopagosGestionImpagos filterCopagosGestionImpagos,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		List<CopagosGestionImpagos> listaCopagosGestionImpagos = this.copagosGestionImpagosDao
				.findAllLike(filterCopagosGestionImpagos, tableRequestDto, false);
		Long recordNum = this.copagosGestionImpagosDao.findAllLikeCount(
				filterCopagosGestionImpagos != null ? filterCopagosGestionImpagos : new CopagosGestionImpagos(), false);
		TableResponseDto<CopagosGestionImpagos> tableResponseDto = new TableResponseDto<CopagosGestionImpagos>(
				tableRequestDto, recordNum, listaCopagosGestionImpagos);

//		if (tableRequestDto.getMultiselection().getSelectedIds() != null
//				&& !tableRequestDto.getMultiselection().getSelectedIds().isEmpty()) {
//			List<TableRowDto<CopagosGestionImpagos>> reorderSelection = this.copagosGestionImpagosDao
//					.reorderSelection(filterCopagosGestionImpagos, tableRequestDto, startsWith);
//			tableResponseDto.setReorderedSelection(reorderSelection);
//			tableResponseDto.addAdditionalParam("reorderedSelection", reorderSelection);
//			tableResponseDto.addAdditionalParam("selectedAll", tableRequestDto.getMultiselection().getSelectedAll());
//		}
//		if (tableRequestDto.getSeeker().getSelectedIds() != null) {
//			tableRequestDto.setMultiselection(tableRequestDto.getSeeker());
//			List<TableRowDto<CopagosGestionImpagos>> reorderSeeker = this.copagosGestionImpagosDao
//					.reorderSelection(filterCopagosGestionImpagos, tableRequestDto, startsWith);
//			tableResponseDto.setReorderedSeeker(reorderSeeker);
//			tableResponseDto.addAdditionalParam("reorderedSeeker", reorderSeeker);
//		}
		return tableResponseDto;
	}

	/**
	 * Reorder the selection made in CopagosGestionImpagos table.
	 *
	 * @param filterCopagosGestionImpagos CopagosGestionImpagos
	 * @param tableRequestDto             TableRequestDto
	 * @param startsWith                  Boolean
	 *
	 * @return Object
	 */
//	public Object reorderSelection(CopagosGestionImpagos filterCopagosGestionImpagos, TableRequestDto tableRequestDto,
//			Boolean startsWith) {
//		return this.copagosGestionImpagosDao.reorderSelection(filterCopagosGestionImpagos, tableRequestDto, startsWith);
//	}
	@Autowired
	private LiquidacionesService liquidacionesService;

	@Override
	public String emitirLiquidacion(List<String> listaSol) {
		for (String sol : listaSol) {
			CopagosGestionImpagos impago = new CopagosGestionImpagos();
			impago.setIdSolicitante(sol);
			impago = this.copagosGestionImpagosDao.findAllLike(impago, null, false).get(0);
			Solicitantes solicitante = this.solicitantesService.find(new Solicitantes(Long.parseLong(sol)));
			System.out.println(impago.getTipoIdentificador());
			try {
				RespuestaType respuesta = new RespuestaType();
				respuesta = this.prepararLlamadaLiquidacion(impago, solicitante);
				return respuesta.getIdLiquidacion();
			} catch (Exception e) {
				CopagosGestionImpagosServiceImpl.logger.error("Ha ocurrido un error al llamar a emitir liquidación");
				ManagerErrors.manageError(e.getMessage());
			}
		}
		return null;
	}

	private RespuestaType prepararLlamadaLiquidacion(CopagosGestionImpagos impagos, Solicitantes solicitante)
			throws NumberFormatException, Exception {

		RespuestaType respuesta = new RespuestaType();
		CabeceraType cabecera = new CabeceraType();
		cabecera.setTipoOperacion(TipoOperacionEnum.EMITIR);
		cabecera.setFComunicacion(UtilidadesFecha.formatearDateToString(UtilidadesFecha.getFechaSistema(),
				com.ejie.ad74a.constantes.Constantes.ES_DATE_MASK));
		cabecera.setUsuario(com.ejie.ad74a.constantes.Constantes.COD_APLICACION);

		DatosEmisionType datosEmision = new DatosEmisionType();
		datosEmision.setTipoIngreso("TLIMP");
		datosEmision.setEjercicio(Integer.parseInt(UtilidadesFecha.getCurrentYear()));

		ConceptoType conceptoType = new ConceptoType();
////			conceptoType.setIdConcepto(2);
		BigDecimal deudaMultiplicada = impagos.getDeuda().multiply(new BigDecimal(100));
		Integer deudaInt = deudaMultiplicada.intValueExact();
		conceptoType.setImporte(deudaInt);
		Conceptos conceptos = new Conceptos();
		conceptos.getConcepto().add(conceptoType);
		datosEmision.setConceptos(conceptos);

		String nuevoOrigen = this.getNuevoOrigen().toString();
		datosEmision.setOrigen(nuevoOrigen);
		Mensualidades mensualidades = new Mensualidades();
		mensualidades.setIdSolicitante89(solicitante.getIdSolicitante01());
		mensualidades.setGrupoImpago89(Long.valueOf(nuevoOrigen));

		// datosEmision.setImporte

//			datosEmision.setFLimitePago("24/09/2024");
		datosEmision.setExpediente(solicitante.getNumAbonado01());
		datosEmision.setConcepto("Teleasistencia. Copagos pendientes: " + this.obtenerDesdeHastaMesAnyo(impagos));
		int territorio = 0;
		if (impagos.getTerritorio().equals("48")) {
			territorio = 3;
		} else if (impagos.getTerritorio().equals("20")) {
			territorio = 2;
		} else {
			territorio = 1;
		}
		datosEmision.setTerritorio(territorio);

		DatosIdentificacionType datosIdentificacionType = new DatosIdentificacionType();
		if (impagos.getTipoIdentificador().equals("1")) { // DNI EN AD74
			datosIdentificacionType.setTipoIdentificador(2);
		} else if (impagos.getTipoIdentificador().equals("2")) { // CIF EN AD74
			datosIdentificacionType.setTipoIdentificador(1);
		} else if (impagos.getTipoIdentificador().equals("4")) { // PASAPORTE EN AD74
			datosIdentificacionType.setTipoIdentificador(3);
		}
		datosIdentificacionType.setIdentificador(impagos.getIdentificador());
		datosIdentificacionType.setNombre(impagos.getNombre());
		datosIdentificacionType.setApellido1(impagos.getApellido1());
		datosIdentificacionType.setApellido2(impagos.getApellido2());
		datosEmision.setDatosIdentificacion(datosIdentificacionType);

		DatosDireccionType datosDireccionType = new DatosDireccionType();

		datosDireccionType.setResidente(1);
		datosDireccionType.setProvincia(null != solicitante.getDirecciones().getProvinciaNORA()
				&& null != solicitante.getDirecciones().getProvinciaNORA().getCodProvincia()
						? solicitante.getDirecciones().getProvinciaNORA().getCodProvincia()
						: null);
		datosDireccionType.setMunicipio(null != solicitante.getDirecciones().getMunicipioNORA()
				&& null != solicitante.getDirecciones().getMunicipioNORA().getCodMunicipio()
						? solicitante.getDirecciones().getMunicipioNORA().getCodMunicipio()
						: null);
		datosDireccionType.setCodLocalidad(null != solicitante.getDirecciones().getLocalidadNORA()
				&& null != solicitante.getDirecciones().getLocalidadNORA().getCodLocalidad()
						? solicitante.getDirecciones().getLocalidadNORA().getCodLocalidad()
						: null);
		datosDireccionType.setLocalidad(null != solicitante.getDirecciones().getLocalidadNORA()
				&& null != solicitante.getDirecciones().getLocalidadNORA().getDescripcion()
						? solicitante.getDirecciones().getLocalidadNORA().getDescripcion()
						: null);
		datosDireccionType.setTipoVia(null != solicitante.getDirecciones().getCalleNORA()
				&& null != solicitante.getDirecciones().getCalleNORA().getTipoVia()
						? solicitante.getDirecciones().getCalleNORA().getTipoVia()
						: null);
		datosDireccionType.setCalle(null != solicitante.getDirecciones().getCalleNORA()
				&& null != solicitante.getDirecciones().getCalleNORA().getDescripcion()
						? solicitante.getDirecciones().getCalleNORA().getDescripcion()
						: null);
		datosDireccionType.setPortal(null != solicitante.getDirecciones().getPortalNORA()
				&& null != solicitante.getDirecciones().getPortalNORA().getCodPortal()
				&& null != solicitante.getDirecciones().getPortalNORA().getCodPortal().toString()
						? solicitante.getDirecciones().getPortalNORA().getCodPortal().toString()
						: null);
		datosDireccionType.setLetra(
				null != solicitante.getDirecciones().getLetra06() ? solicitante.getDirecciones().getLetra06() : null);
		datosDireccionType.setPiso(
				null != solicitante.getDirecciones().getPiso06() ? solicitante.getDirecciones().getPiso06() : null);
		datosDireccionType.setCodigoPostal(
				null != solicitante.getDirecciones().getCp06() ? solicitante.getDirecciones().getCp06() : null);
		datosDireccionType.setEscalera(
				null != solicitante.getDirecciones().getEscalera06() ? solicitante.getDirecciones().getEscalera06()
						: null);
		datosEmision.setDatosDireccion(datosDireccionType);

		DatosBancariosType datosBancarios = new DatosBancariosType();
		datosBancarios.setDomiciliacion(0);
		datosEmision.setDatosBancarios(datosBancarios);

		try {
			respuesta = this.liquidacionesService.emitirLiquidacion(cabecera, datosEmision);
		} catch (Exception_Exception e) {
			throw new Ad74aException(e.getMessage());
		}
		if (respuesta.getIdLiquidacion() != null) {
			mensualidades = this.actualizarImpagos(mensualidades);
		} else {
			throw new Ad74aException(respuesta.getMensaje());
		}

		StringBuilder respuestaStr = new StringBuilder();

		respuestaStr.append("codRespuesta: " + respuesta.getCodRespuesta());
		respuestaStr.append("mensaje: " + respuesta.getMensaje());
		respuestaStr.append("idLiquidacion: " + respuesta.getIdLiquidacion());
		respuestaStr.append("fecha: " + respuesta.getFRespuesta());
		CopagosGestionImpagosServiceImpl.logger.info(respuestaStr.toString());
		// model.addAttribute("msg", respuestaStr.toString());
		// return "accessDeniedIntegrado";
		return respuesta;

	}

	String obtenerDesdeHastaMesAnyo(CopagosGestionImpagos copagosGestionImpagos) {

		return this.copagosGestionImpagosDao.obtenerDesdeHastaMesAnyo(copagosGestionImpagos);
	}

	public Long getNuevoOrigen() {

		return this.mensualidadesService.getLastGrupoImpagoMensualidades();
	}

	public Mensualidades actualizarImpagos(Mensualidades mensualidades) {
		return this.mensualidadesService.updateCopagosGestionImpagos(mensualidades);
	}

	/**
	 * Devuelve un fichero en el formato deseado que contiene los datos exportados
	 * de la tabla.
	 *
	 * @param filterAvisos    Avisos
	 * @param columns         String[]
	 * @param fileName        String
	 * @param sheetTitle      String
	 * @param reportsParams   ArrayList<?>
	 * @param tableRequestDto TableRequestDto
	 * @param request         HttpServletRequest
	 * @param response        HttpServletResponse
	 */
	@Override
	public void generateReport(CopagosGestionImpagos filterImpagos, String[] columns, String[] columnsName,
			String fileName, String sheetTitle, TableRequestDto tableRequestDto, HttpServletRequest request,
			HttpServletResponse response) {
		// Accede a la DB para recuperar datos
		List<CopagosGestionImpagos> filteredData = getDataForReports(filterImpagos, tableRequestDto);
		String extension = null;

		// Comprobar si las siguientes variables estan vacias, en caso de estarlo se las
		// asigna un valor generico
		fileName = (fileName != null && !fileName.isEmpty()) ? fileName : "report";
		sheetTitle = (sheetTitle != null && !sheetTitle.isEmpty()) ? sheetTitle
				: CopagosGestionImpagos.class.getSimpleName();

		// Obtener el formato de fecha especifico del locale
		SimpleDateFormat formatter = DateTimeManager.getDateTimeFormat(request.getLocale());

		// Cuando no se definen columnas porque se quieren obtener todas
		if (columns == null) {
			Field[] fields = CopagosGestionImpagos.class.getDeclaredFields();
			ArrayList<String> tempColumns = new ArrayList<String>();

			for (int i = 0; i < fields.length; i++) {
				try {
					String methodName = fields[i].getName();
					methodName = methodName.substring(0, 1).toUpperCase() + methodName.substring(1);
					Avisos.class.getMethod("get" + methodName);
					tempColumns.add(fields[i].getName());
				} catch (NoSuchMethodException e) {
					e.printStackTrace();
				}

			}
			columns = tempColumns.toArray(new String[0]);
		}

		// si no se definen el nombre de las columnas , se dejan las de por defecto.
		if (columnsName == null) {
			columnsName = columns;
		}

		String servletPath = request.getServletPath();
		String reportType = null;
		if (servletPath.contains("/") && (servletPath.lastIndexOf("/") + 1 != servletPath.length())) {
			reportType = servletPath.substring(servletPath.lastIndexOf("/") + 1, servletPath.length());
		} else {
			reportType = servletPath.substring(0, servletPath.length());
		}

		if (reportType.equals("xlsReport")) {
			extension = ".xls";
			generateExcelReport(filteredData, columns, columnsName, fileName, sheetTitle, extension, formatter,
					response);
		} else if (reportType.equals("xlsxReport")) {
			extension = ".xlsx";
			generateExcelReport(filteredData, columns, columnsName, fileName, sheetTitle, extension, formatter,
					response);
		} else if (reportType.equals("pdfReport")) {
			extension = ".pdf";
			generatePDFReport(filteredData, columns, columnsName, fileName, response);
		} else if (reportType.equals("odsReport")) {
			extension = ".ods";
			generateODSReport(filteredData, columns, columnsName, fileName, sheetTitle, response);
		} else if (reportType.equals("csvReport")) {
			extension = ".csv";
			// Obtener idioma
			String language = request.getLocale().getLanguage();
			generateCSVReport(filteredData, columns, columnsName, fileName, sheetTitle, language, response);
		}

	}

	/**
	 * Devuelve los datos recuperados de la DB.
	 *
	 * @param filterAvisos    Avisos
	 * @param tableRequestDto TableRequestDto
	 */
	private List<CopagosGestionImpagos> getDataForReports(CopagosGestionImpagos filterImpagos,
			TableRequestDto tableRequestDto) {
		if (tableRequestDto.getMultiselection().getSelectedAll()
				&& tableRequestDto.getMultiselection().getSelectedIds().isEmpty()) {
			if (filterImpagos != null) {
				return this.copagosGestionImpagosDao.findAllLikeExcel(filterImpagos, tableRequestDto, false);
			} else {
				return this.copagosGestionImpagosDao.findAllExcel(new CopagosGestionImpagos(), null);
			}
		} else {
			return this.copagosGestionImpagosDao.findAllLikeExcel(filterImpagos, tableRequestDto, false);
		}
	}

	/**
	 * Devuelve un fichero excel que contiene los datos exportados de la tabla.
	 *
	 * @param filteredData List<Avisos>
	 * @param columns      String[]
	 * @param fileName     String
	 * @param sheetTitle   String
	 * @param extension    String
	 * @param formatter    SimpleDateFormat
	 * @param response     HttpServletResponse
	 */
	private void generateExcelReport(List<CopagosGestionImpagos> filteredData, String[] columns, String[] columnsName,
			String fileName, String sheetTitle, String extension, SimpleDateFormat formatter,
			HttpServletResponse response) {
		try {
			// Creacion del Excel
			Workbook workbook = null;
			if (extension == ".xlsx") {
				workbook = new XSSFWorkbook();
				response.setContentType("application/vnd.openxmlformats-officedocument.spreadsheetml.sheet");
			} else {
				workbook = new HSSFWorkbook();
				response.setContentType("application/vnd.ms-excel");
			}

			response.setHeader("Content-Disposition", "attachment; filename=" + fileName + extension + "");

			// Creacion de una hoja y asignacion de su nombre
			Sheet sheet = workbook.createSheet(sheetTitle);

			// Se crea una fuente para estilizar las cabeceras
			Font headerFont = workbook.createFont();
			headerFont.setBold(true);
			headerFont.setFontHeightInPoints((short) 12);

			// Se crea un CellStyle con la fuente
			CellStyle headerCellStyle = workbook.createCellStyle();
			headerCellStyle.setAlignment(HorizontalAlignment.CENTER);
			headerCellStyle.setFont(headerFont);

			// Inicializar contador de filas
			int rowNumber = 0;

			// Se crea la fila para insertar los titulos de las columnas
			Row row = sheet.createRow(rowNumber++);

			// Añadir titulos
			for (int i = 0; i < columnsName.length; i++) {
				Cell cell = row.createCell(i);
				cell.setCellValue(
						UtilLiterales.getLiteralMessage(appMessageSource, "excelReportLiteral." + columnsName[i]));
				cell.setCellStyle(headerCellStyle);
			}

			// CreationHelper ayudara a mantener la compatibilidad del DataFormat tanto si
			// se crea un .xls como un .xlsx
			CreationHelper createHelper = workbook.getCreationHelper();

			// Se crea un CellStyle para añadir el formateador de fechas
			CellStyle dateCellStyle = workbook.createCellStyle();
			dateCellStyle.setDataFormat(createHelper.createDataFormat().getFormat(formatter.toPattern()));

			CellStyle CellStyleRight = workbook.createCellStyle();
			CellStyleRight.setAlignment(HorizontalAlignment.RIGHT);

			// Añadir datos
			for (CopagosGestionImpagos rowImpagos : filteredData) {
				int cellNumber = 0;
				row = sheet.createRow(rowNumber++);

				// Se iteran las columnas y se insertan los datos respetando el orden que tenian
				// las columnas en la tabla
				for (String column : columns) {
					Cell cellImpagos = row.createCell(cellNumber++);
					cellImpagos.setCellValue(getCellValue(column, rowImpagos));

					if (column.equals("cantidadMensualidades") || column.equals("deudaStr")) {
						cellImpagos.setCellStyle(CellStyleRight);
					}
				}
			}

			// Se adapta el ancho de las columnas al contenido
			for (int i = 0; i < columns.length; i++) {
				sheet.autoSizeColumn(i);
			}

			// Se añade el fichero excel al response
			workbook.write(response.getOutputStream());
			workbook.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	/**
	 * Obtiene los valores de las celdas.
	 *
	 * @param column    String
	 * @param rowAvisos Avisos
	 */
	private String getCellValue(String column, CopagosGestionImpagos rowImpagos) {
		String cellValue = "";
		try {
			cellValue = BeanUtils.getProperty(rowImpagos, column) != null ? BeanUtils.getProperty(rowImpagos, column)
					: "";
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			e.printStackTrace();
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
		}

		return cellValue;
	}

	/**
	 * Devuelve un fichero pdf que contiene los datos exportados de la tabla.
	 *
	 * @param filteredData List<CopagosGestionImpagos>
	 * @param columns      String[]
	 * @param fileName     String
	 * @param response     HttpServletResponse
	 */
	private void generatePDFReport(List<CopagosGestionImpagos> filteredData, String[] columns, String[] columnsName,
			String fileName, HttpServletResponse response) {
		try {
			// Se añade el fichero excel al response y se añade el contenido
			response.setHeader("Content-Disposition", "attachment; filename=" + fileName + ".pdf");
			response.setContentType("application/pdf");

			Document document = new Document();
			// Se añade el fichero pdf al response
			PdfWriter.getInstance(document, response.getOutputStream());

			document.open();

			PdfPTable table = new PdfPTable(columns.length);

			for (String column : columnsName) {
				PdfPCell header = new PdfPCell();
				header.setBorderWidth(2);
				header.setPhrase(new Phrase(column));
				table.addCell(header);
			}

			// Añadir datos
			for (CopagosGestionImpagos rowImpagos : filteredData) {
				// Se iteran las columnas y se insertan los datos respetando el orden que tenian
				// las columnas en la tabla
				for (String column : columns) {
					table.addCell(getCellValue(column, rowImpagos));
				}
			}

			document.add(table);
			document.close();

		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Devuelve un fichero ods que contiene los datos exportados de la tabla.
	 *
	 * @param filteredData List<Avisos>
	 * @param columns      String[]
	 * @param fileName     String
	 * @param sheetTitle   String
	 * @param response     HttpServletResponse
	 */
	private void generateODSReport(List<CopagosGestionImpagos> filteredData, String[] columns, String[] columnsName,
			String fileName, String sheetTitle, HttpServletResponse response) {
		try {
			// Se añade el fichero ods al response y se añade el contenido
			response.setHeader("Content-Disposition", "attachment; filename=" + fileName + ".ods");
			response.setContentType("application/vnd.oasis.opendocument.spreadsheet");

			OdfSpreadsheetDocument ods = OdfSpreadsheetDocument.newSpreadsheetDocument();
			ods.getOrCreateDocumentStyles();

			// Hay que eliminar la hoja que se genera por defecto
			ods.getTableByName("Sheet1").remove();

			// Hoja nueva
			OdfTable table = OdfTable.newTable(ods, filteredData.size() + 1, columns.length);
			table.setTableName(sheetTitle);

			// Inicializar contador de filas
			int rowNumber = 0;

			// Cabeceras
			OdfTableRow row = table.getRowByIndex(rowNumber++);
			for (int i = 0; i < columnsName.length; i++) {
				row.getCellByIndex(i).setStringValue(columnsName[i]);
			}

			// Añadir datos
			for (CopagosGestionImpagos rowImpagos : filteredData) {
				row = table.getRowByIndex(rowNumber++);
				int cellNumber = 0;

				// Se iteran las columnas y se insertan los datos respetando el orden que tenian
				// las columnas en la tabla
				for (String column : columns) {
					row.getCellByIndex(cellNumber++).setStringValue(getCellValue(column, rowImpagos));
				}
			}

			// Se añade el fichero ods al response
			ods.save(response.getOutputStream());
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Devuelve un fichero csv que contiene los datos exportados de la tabla.
	 *
	 * @param filteredData List<CopagosGestionImpagos>
	 * @param columns      String[]
	 * @param fileName     String
	 * @param sheetTitle   String
	 * @param language     String
	 * @param response     HttpServletResponse
	 */
	private void generateCSVReport(List<CopagosGestionImpagos> filteredData, String[] columns, String[] columnsName,
			String fileName, String sheetTitle, String language, HttpServletResponse response) {
		try {
			// Se añade el fichero excel al response y se añade el contenido
			response.setHeader("Content-Disposition", "attachment; filename=" + fileName + ".csv");
			response.setContentType("text/csv");

			// Separador de campos dependiendo del idioma
			String separator = ";";
			if (language.equals("en")) {
				separator = ",";
			}

			// Se añade el fichero csv al response
			OutputStream out = response.getOutputStream();
			// Añadir titulos
			boolean addTitles = true;

			// Añadir datos
			for (CopagosGestionImpagos rowImpagos : filteredData) {
				int cellNumber = 1;
				StringBuilder columnsTitles = new StringBuilder();
				StringBuilder row = new StringBuilder();

				// Se iteran las columnas y se insertan los datos respetando el orden que tenian
				// las columnas en la tabla
				for (String column : columns) {
					String cellValue = getCellValue(column, rowImpagos);

					if (cellNumber < columns.length) {
						if (addTitles) {
							columnsTitles.append("\"");
							columnsTitles.append(column);
							columnsTitles.append("\"");
							columnsTitles.append(separator);
						}
						row.append("\"");
						row.append(cellValue);
						row.append("\"");
						row.append(separator);
						cellNumber++;
					} else {
						if (addTitles) {
							columnsTitles.append("\"");
							columnsTitles.append(column);
							columnsTitles.append("\"\n");
						}
						row.append("\"");
						row.append(cellValue);
						row.append("\"\n");
					}
				}

				if (addTitles) {
					out.write(columnsTitles.toString().getBytes());
					addTitles = false;
				}
				out.write(row.toString().getBytes());
			}
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
